'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createAppStateFactory = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reactRouterRedux = require('react-router-redux');

var _reduxEventsMiddleware = require('redux-events-middleware');

var _createSsrContext = require('./create-ssr-context');

var _decorateStore = require('react-redux-feature/lib/decorate-store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createAppStateFactory = exports.createAppStateFactory = function createAppStateFactory() {
    var appReducers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var appFeatures = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    return function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            var initialState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var history = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

            var events, ssrContext, middlewares, enhancers, _window, devToolsExtension, composedEnhancers, initialReducers, combinedReducers, store;

            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            events = new _reduxEventsMiddleware.ReduxEvents();
                            ssrContext = (0, _createSsrContext.createSSRContext)(initialState.ssr || {});
                            middlewares = [_reduxThunk2.default, (0, _reactRouterRedux.routerMiddleware)(history), events.createReduxMiddleware({ history: history })];

                            // @DEV: redux dev tools (development & client only)

                            enhancers = [];

                            if (process.env.NODE_ENV === 'development' && !process.env.SSR) {
                                _window = window, devToolsExtension = _window.devToolsExtension;


                                if (typeof devToolsExtension === 'function') {
                                    enhancers.push(devToolsExtension());
                                }
                            }

                            composedEnhancers = _redux.compose.apply(undefined, [_redux.applyMiddleware.apply(undefined, middlewares)].concat(enhancers));
                            initialReducers = (0, _extends3.default)({}, appReducers, (0, _decorateStore.getReducers)(appFeatures), ssrContext.reducers);
                            combinedReducers = (0, _redux.combineReducers)(initialReducers);

                            // redux store gets created

                            store = (0, _redux.createStore)(combinedReducers, initialState, composedEnhancers);

                            // react-redux-features
                            // add features capabilities to the store

                            store = (0, _decorateStore.decorateStore)({ store: store, history: history, events: events, initialReducers: initialReducers });

                            // Initialize dynamic stuff
                            _context.next = 12;
                            return store.registerSyncFeatures(appFeatures);

                        case 12:
                            _context.next = 14;
                            return store.startSyncFeatures();

                        case 14:

                            // @DEV: expose the store for the console to dispatch actions
                            if (process.env.NODE_ENV === 'development' && !process.env.SSR) {
                                window.store = store;
                            }

                            return _context.abrupt('return', {
                                store: store,
                                history: history,
                                events: events,
                                ssrContext: ssrContext
                            });

                        case 16:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, undefined);
        }));

        return function () {
            return _ref.apply(this, arguments);
        };
    }();
};